% Compute < nk | S | n'k >
% run over all the S operator %

function result = BlochSBloch(Atom, Psp, ibz, wave1, wave2, volume)
  
  atomMax  = Atom.AtomMax;
  atomtype = Atom.Atom2Type;
  atom_phase = Atom.Phase;
  
  result = BlochBloch(wave1, wave2, volume);
  
  for iatom = 1 : atomMax,
    type = atomtype(iatom);
    for iproj = 1 : Psp{type}.projMax,
      for jproj = 1 : Psp{type}.projMax,
        if ( abs(Psp{type}.Q(iproj,jproj)) > 1e-6),
          result = result + Psp{type}.Q(iproj,jproj) * ...
                   conj(QuickProjBloch( atom_phase(iatom, :, ibz), ...
                                            Psp{type}.projK(iproj, :, ibz), ...
                                            wave1, volume)) * ...
                   QuickProjBloch( atom_phase(iatom, :, ibz), ...
                                       Psp{type}.projK(jproj, :, ibz), ...
                                       wave2, volume );
          
        end;
      end;
    end;
  end;
  