% GenEigVD.m %

function [V, D] = GenEigVD(A,B,tol)
  
  P = B * A * B;
  [PV,PD] = eig(P);
  Pd = diag(PD);
  Pnorm = norm(P,'fro');
  
  idx = find( (abs(Pd)).^(1/3) > tol*(Pnorm).^(1/3) );
  
  perspective = PV(:,idx);
  
  [V, DD] = eig(perspective'*A*perspective, perspective'*B*perspective);
  
  V = perspective*V;
  
  D = diag(DD);