% RadialIntegralLog.m %

function result=RadialIntegralLog(mesh,func,rab)
  
  func = reshape(func,1,mesh);
  rab  = reshape(rab,1,mesh);
  asum = 0.0d0;
  r12 = 1.0 / 3.0;
  len = round((mesh-1)/2);
  f1 = zeros(1,len);
  f2 = zeros(1,len);
  f3 = zeros(1,len);
  
  f3 = r12 * func(1,3:2:mesh) .* rab(1,3:2:mesh);
  f1(1,2:len) = f3(1,1:(len-1));
  f1(1,1) = func(1) * rab(1) * r12;
  f2 = func(1,2:2:(mesh-1)) .* rab(1,2:2:(mesh-1)) * r12;

  result = sum(f1 + 4.0*f2 + f3);
  
  return;
  

