% QuickCutPlane2.m %

fprintf(1,'QuickCutPlane2: Initializing\n');

LBruteForce = 0;
ispin = 1;
iatom = 1;
iorb = 6;
type = atomtype(iatom);

deltax = 1/2;
deltay = deltax;

% Al %
% [x, z] = meshgrid(-6:1/8:6,-5:1/10:5); %
[x, y, z] = meshgrid(0, -8:deltax:8,-8:deltay:8);

% CO %
% [x, z] = meshgrid(0:1/8:8,0:1/8:8); %

% x = y *0;  %
% phi = y * 0; %


% d0 = H(3,1); %
% sqrt(d0)/2 %

% y = x ; %
% y = ones(size(x,1),size(x,2)); %

WaveAmp = zeros(IBZKMax, size(BlochBasis{1,ispin,1}.a,2));

for ibz = 1 : IBZKMax,
  for ispin = 1 : number_of_spin,
    for iband = 1 : number_of_bands,
      WaveAmp(ibz,:) = WaveAmp(ibz,:) + ...
          BlochBasis{ibz,ispin,iband}.orbS(iatom,iorb) * ...
          BlochBasis{ibz,ispin,iband}.a;
      end;
  end;
end;

dim1 = size(squeeze(x),1);
dim2 = size(squeeze(x),2);
phi = zeros(dim1, dim2);
phase =[];
K = [];

if (LBruteForce == 1),
  
  WaveAmp = WaveAmp.';
  fprintf(1,'QuickCutPlane: Generating cut-plane\n');
  fprintf(1,'ibz = ');
  for ibz = 1 : IBZKMax,
    K = GList(1:number_plane_waves, :) + repmat(IBZK(ibz,:), number_plane_waves, 1);
    for iwave = 1 : number_plane_waves,
      phase(:,:,iwave) = K(iwave,1)*squeeze(x) + ...
          K(iwave,2)*squeeze(y) + ...
          K(iwave,3)*squeeze(z);
    end;
    tmpphase = reshape(phase, dim1*dim2, number_plane_waves);
    phi = phi + ...
          IBZKWeight(ibz) * real ( reshape(exp( j * tmpphase(:,:))*WaveAmp(:,ibz), ...
                                           dim1, dim2 ) );
  
    fprintf(1,'%d ',ibz);
  end;
  
  figure;
%   contour(squeeze(x), squeeze(z), real(phi),16); %
  contour(real(phi),16);
  
  % figure; %
  % mesh(x,z,real(phi)); %
  
else
  
  phi = x *0.;
  
  for ibz = 1 : IBZKMax,
    fprintf(1,'%d ',ibz);
    [GIndex, ingx, ingy, ingz] = GIndexGenerator(ibz,0,0); 
    GIndex = GIndex .*(GIndex>0);
    Gmin = round(min(find(GIndex(:)==0)-1));
    if isempty(Gmin)
      Gmin=length(GIndex);
    end;
    
    GQuamboReshaped = zeros(1,ingx*ingy*ingz);
    GQuamboReshaped(1, GIndex(1:Gmin,1)) = WaveAmp(ibz,1:Gmin);
    GQuamboPlaneReshaped = reshape(GQuamboReshaped, ingx,ingy,ingz);
    QuamboCube  = ifftn(GQuamboPlaneReshaped) ;
    QuamboPlane = interp3(QuamboCube,x,y,z);
    K = GList(1:number_plane_waves, :) + repmat(IBZK(ibz,:), number_plane_waves, 1);
%     phase = K(1)*x + K(2)*y + K(3)*z; %
%     for iwave = 1 : number_plane_waves, %
%       phase(:,:,iwave) = K(iwave,1)*squeeze(x) + ... %
%           K(iwave,2)*squeeze(y) + ... %
%           K(iwave,3)*squeeze(z); %
%     end; %
%      %
%     phi = phi + 2 * real(squeeze(QuamboPlane) .* exp( j * phase ) ); %
    
  end;
  
  contour(real(squeeze(QuamboPlane)),20);
end;

