% QuickOutputXSF.m %

function [ierror,str_error] = ...
      QuickOutputXSF(xsfblock,xsfname,data, idim, ...
                     ShellGrid, H, ...
                     atom_X, AtomicNumber);
  xsffull = xsfname;
  fid_xsf = fopen(xsffull,'wt');
  if (fid_xsf<0)
    ierror = -1;
    str_error = ['QuickOutput: Cannot creat file ' xsffull];
    return;
  end;
  
  atomMax = size(atom_X,1);
  ingx = ShellGrid(1);
  ingy = ShellGrid(2);
  ingz = ShellGrid(3);
  
  fprintf(fid_xsf,'ATOMS\n');
  for iatom = 1 : atomMax,
    fprintf(fid_xsf,'%d  %f %f %f\n',...
            AtomicNumber(iatom), atom_X(iatom,1),atom_X(iatom,2),atom_X(iatom,3));
  end;
  
  if (idim == 3),
    fprintf(fid_xsf,'BEGIN_BLOCK_DATAGRID_3D\n'); 
    fprintf(fid_xsf,'DFT_%s\n',xsfblock);
    fprintf(fid_xsf,'BEGIN_DATAGRID_3D_%s\n',xsfblock);
    fprintf(fid_xsf,'%d %d %d\n',ingx,ingy,ingz);
    
    s = [0 0 0];
    Hgeneral = diag((ShellGrid-1)./ShellGrid) * H; 
    fprintf(fid_xsf,'%f %f %f\n',s(1), s(2), s(3) );
    fprintf(fid_xsf,'%f %f %f\n',Hgeneral(1,1),Hgeneral(1,2),Hgeneral(1,3));
    fprintf(fid_xsf,'%f %f %f\n',Hgeneral(2,1),Hgeneral(2,2),Hgeneral(2,3));
    fprintf(fid_xsf,'%f %f %f\n',Hgeneral(3,1),Hgeneral(3,2),Hgeneral(3,3));    

    id=0;
    for iz = 1:ingz,
      for iy = 1:ingy,
        for ix = 1:ingx,
          fprintf(fid_xsf,'%f ',data(ix,iy,iz));
          id = id + 1;
          if (id == 8) ,
            id =0;
            fprintf(fid_xsf,'\n');
          end;
        end;
      end;
    end;
    
    fprintf(fid_xsf,'END_DATAGRID_3D\n');
    fprintf(fid_xsf,'END_BLOCK_DATAGRID_3D\n');
    fclose(fid_xsf);
    ierror = 0;
    str_error = ...
        ['\n[QuickOutputXSF] QuickOutput Succeed Generating file: ' xsffull '\n\n'];
    fprintf(1, str_error);

    return;
    
  else 
    ierror = 1;
    str_error = ['\n[QuickOutputXSF] Error: Dimension should be 3. \n\n'];
    fprintf(1, str_error);
    return;
  end;
  
  
  
  
